/*******************************************************************
  Key Value Persistent Storage

  keyval_dinfo.h	- dinfo storage/retrieve 

  (C) Copyright 2003-2005 by Pavel Pisa - Originator

  The uLan utilities library can be used, copied and modified under
  next licenses
    - GPL - GNU General Public License
    - LGPL - GNU Lesser General Public License
    - MPL - Mozilla Public License
    - and other licenses added by project originators
  Code can be modified and re-distributed under any combination
  of the above listed licenses. If contributor does not agree with
  some of the licenses, he/she can delete appropriate line.
  Warning, if you delete all lines, you are not allowed to
  distribute source code and/or binaries utilizing code.
  
  See files COPYING and README for details.

 *******************************************************************/

#ifndef _KEYVAL_DINFO_H
#define _KEYVAL_DINFO_H

struct kvpb_block;

struct kvpb_di_list;

struct ul_dbuff;

#define KVPB_DINFOS_IGNORE_ERR_VAL 0x01
#define KVPB_DINFOS_IGNORE_DIFF_COMP_TYPES 0x02 /* ignore different but compatible types */

int kvpb_dinfos2dbuff(struct ul_dbuff *pdbuf, struct kvpb_di_list *dilist, int options);
int kvpb_dbuff2dinfos(const struct ul_dbuff *pdbuf, struct kvpb_di_list *dilist, int options);
int kvpb_compare_dbuff2dinfos(const struct ul_dbuff *pdbuf, struct kvpb_di_list *dilist);

int kvpb_dinfos2store(struct kvpb_block *store, struct kvpb_di_list *dilist, int keyid);
int kvpb_store2dinfos(struct kvpb_block *store, struct kvpb_di_list *dilist, int keyid);
int kvpb_compare_store2dinfos(struct kvpb_block *store, struct kvpb_di_list *dilist, int keyid);

struct kvpb_di_list *kvpb_di_list_new(void);
int kvpb_di_list_init(struct kvpb_di_list *dilist);
int kvpb_di_list_done(struct kvpb_di_list *dilist);

int kvpb_di_list_print(struct kvpb_di_list *dilist);

int kvpb_di_list_add(struct kvpb_di_list *dilist, char *name, int name_len, int min_idx, int max_idx, int flags);

#endif /*_KEYVAL_DINFO_H*/
