/*******************************************************************
  Key Value Persistent Storage

  keyval_passwd.h	- password and capabilities management

  (C) Copyright 2003-2005 by Pavel Pisa - Originator

  The uLan utilities library can be used, copied and modified under
  next licenses
    - GPL - GNU General Public License
    - LGPL - GNU Lesser General Public License
    - MPL - Mozilla Public License
    - and other licenses added by project originators
  Code can be modified and re-distributed under any combination
  of the above listed licenses. If contributor does not agree with
  some of the licenses, he/she can delete appropriate line.
  Warning, if you delete all lines, you are not allowed to
  distribute source code and/or binaries utilizing code.
  
  See files COPYING and README for details.

 *******************************************************************/

#ifndef _KEYVAL_PASSWD_H
#define _KEYVAL_PASSWD_H

#define KVSEC_UID_ROOT      0
#define KVSEC_UID_PRODUCER  1
#define KVSEC_UID_SERVICE   2
#define KVSEC_UID_ANONYMOUS 3

typedef unsigned long keyval_caps_t;

int keyval_passwd_init(char *name, int number);

int keyval_uid_get(char *name_str, int name_len);
int keyval_uid_new(char *name_str, int name_len);
int keyval_uid_name_get(int uid, char **pname, int *pname_len);
int keyval_uid_for_each(int(*callfnc)(void *context, int uid, const char *name, int name_len),
                          void *context);
int keyval_passwd_check(int uid, char *passwd, int passwd_len, int single);
int keyval_passwd_set(int uid, char *passwd, int passwd_len, int single);

int keyval_caps_get(int uid, keyval_caps_t* caps);
int keyval_caps_set(int uid, const keyval_caps_t* caps);

int keyval_check_password_forshell(int argc, char **argv);
int keyval_add_user_forshell(int argc, char **argv);
int keyval_set_password_forshell(int argc, char **argv);

#endif /*_KEYVAL_PASSWD_H*/
